import { BrowserModule } from '@angular/platform-browser';
import { ErrorHandler, NgModule } from '@angular/core';
import { IonicApp, IonicErrorHandler, IonicModule } from 'ionic-angular';
import { SplashScreen } from '@ionic-native/splash-screen';
import { StatusBar } from '@ionic-native/status-bar';

import { Facebook } from '@ionic-native/facebook';

import { MyApp } from './app.component';
import { LoginServiceProvider } from '../providers/login-service/login-service';
import { HttpModule } from '@angular/http';
import { IonicStorageModule } from '@ionic/storage';
import { LocalStorageProvider } from '../providers/local-storage/local-storage';
import { GoogleMaps, Geocoder  } from '@ionic-native/google-maps';
import { QuedadasApiProvider } from '../providers/quedadas-api/quedadas-api';
import { Geolocation } from '@ionic-native/geolocation';
import { NativeGeocoder, NativeGeocoderReverseResult, NativeGeocoderForwardResult } from '@ionic-native/native-geocoder';
import { GeocoderProvider } from '../providers/geocoder/geocoder';
import { GlobalvarsProvider } from '../providers/globalvars/globalvars';
import { Device } from '@ionic-native/device';
import { FCM } from '@ionic-native/fcm';
import { LaunchNavigator } from '@ionic-native/launch-navigator';
import { SocialSharing } from '@ionic-native/social-sharing';
import { TwitterConnect } from '@ionic-native/twitter-connect';
import { Deeplinks } from '@ionic-native/deeplinks';
import { PipesModule} from '../pipes/pipes.module';

@NgModule({
  declarations: [
    MyApp

  
  ],
  imports: [
    BrowserModule,
    HttpModule,
    PipesModule,
    IonicModule.forRoot(MyApp),
    IonicStorageModule.forRoot()
  ],
  bootstrap: [IonicApp],
  entryComponents: [
    MyApp
  ],
  providers: [
    StatusBar,
    SplashScreen,
    {provide: ErrorHandler, useClass: IonicErrorHandler},
    Facebook,
    GoogleMaps,
    Geolocation,
    Geocoder,
    NativeGeocoder,
    LoginServiceProvider,
    LocalStorageProvider,
    QuedadasApiProvider,
    GeocoderProvider,
    GlobalvarsProvider,
    GlobalvarsProvider,
    Device,
    FCM,
    LaunchNavigator,
    SocialSharing,
    TwitterConnect,
    Deeplinks
  ]
})
export class AppModule {}
