import { DateTime } from "ionic-angular";
import { UserModel} from "../models/user"

export class QuedadaModel{
    constructor(
        public name:string,
        public details:string,
        public observations:string,
        public dateTimeUtc:DateTime,
        public location:string,
        public latitude:number,
        public longitude:number,
        public maxAttendees:number = 0,
        public duration:number = 0,

        public owner:UserModel,
        public attendees:UserModel[]
    ){}

    static fromJson(data:any){
        if(!data.name || !data.details)
            throw(new Error("No se ha recibido una quedada o los parametro son erroneos"));
        return new QuedadaModel(data.name, data.details, data.observations, data.dateTimeUtc, data.location, data.latitude, data.longitude
            ,  data.maxAttendees, data.duration, data.owner, data.attendees);
    }
}