import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams,  ViewController, ModalController } from 'ionic-angular';
import { MapPage } from '../map/map'
import { QuedadasApiProvider} from '../../providers/quedadas-api/quedadas-api'
import { GlobalvarsProvider} from '../../providers/globalvars/globalvars';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { AlertController } from 'ionic-angular';
import { FCM } from '@ionic-native/fcm';

/**
 * Generated class for the CreateQuedadaPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@IonicPage()
@Component({
  selector: 'page-create-quedada',
  templateUrl: 'create-quedada.html',
})
export class CreateQuedadaPage {
  datetoshow2: any;
  place: string;
  address: string;
  quedadaForm: FormGroup;
  participantes: any;
  isDuration: boolean = false;
  latitudeMap: number;
  longitudeMap: number;
  isEdit: boolean;
  dateUTC = (new Date()).toISOString();
  quedada: any = [];
  timeQuedada: string;
  
  constructor(public navCtrl: NavController, public navParams: NavParams, public modalCtrl: ModalController, 
      public quedadasApiProvider: QuedadasApiProvider, public viewCtrl: ViewController, public globalvars: GlobalvarsProvider, 
      public formBuilder: FormBuilder, private alertCtrl: AlertController, private fcm: FCM) {
    this.quedadaForm = this.CreateQuedadaForm();
    this.participantes = 'Sin limite';
    if(this.address)
    {
      
    }
    else{
      if(navParams.get("quedada")){
        this.quedada = navParams.get("quedada");
        this.isEdit = true;
      }else{
        this.isEdit = false;
      }
      
    }
    this.fcm.getToken().then(token => {
      
      });
  }

  private CreateQuedadaForm(){
    return this.formBuilder.group({
      titulo: ['', Validators.required],
      queHacer: ['',],
      queSaber: ['',],
      dateQuedada: ['', Validators.required],
      dateQuedadaH: ['', Validators.required],
      lugar: ['', ],
      direccion: ['', Validators.required],
      people: ['',],
      duracion: ['',]
    });
  }

  setparticipantes() {
    this.participantes = this.quedadaForm.controls['people'].value;
    if(this.participantes == 0)
    {
      this.participantes = 'sin limite';
    }
    if(this.participantes == 50)
    {
      this.participantes = 'A reventar de gente';
    }
  }

  setIsDuration(){
    if(this.isDuration){
      this.isDuration = false;
    }else{
      this.isDuration = true;
    }
  }

  showMap(){
    //let modal = this.modalCtrl.create('MapPage');
    //modal.present();
    this.place = this.quedadaForm.controls['lugar'].value;
    this.navCtrl.push('MapPage', { direccion: this.place});
  }

  

  ionViewDidLoad() {
    this.globalvars.setMyGlobalVar('');
    this.globalvars.setLatitudeGlobal(0);
    this.globalvars.setLongitudeGlobal(0);
     this.datetoshow2 = new Date(this.quedada.DateTimeUtc);
     let nDate = new Date(this.quedada.dateTimeUtc.substr(0,10)+'T'+this.quedada.dateTimeUtc.substr(11,9));
     var day = nDate.getDate();
     var month = nDate.getMonth()+1;
     var year = nDate.getFullYear();
     var n = nDate.getHours();
     var m = nDate.getMinutes();
    var ml = nDate.getSeconds();
     this.quedadaForm.controls['titulo'].setValue(this.quedada.name);
     this.quedadaForm.controls['queHacer'].setValue(this.quedada.details);
     this.quedadaForm.controls['queSaber'].setValue(this.quedada.observations);
     this.quedadaForm.controls['direccion'].setValue(this.quedada.location);
     this.participantes = this.quedada.maxAttendees;
     this.quedadaForm.controls['people'].setValue(this.quedada.maxAttendees);
     this.quedadaForm.controls['duracion'].setValue(this.quedada.duration);
     this.quedadaForm.controls['dateQuedada'].setValue(nDate.toISOString());
     this.quedadaForm.controls['dateQuedadaH'].setValue(year+'-'+("00" + month).substr(-2,2)+'-'+("00" + day).substr(-2,2)+'T'+("00" + n).substr(-2,2)+':'
              +("00" + m).substr(-2,2)+':'+("00" + ml).substr(-2,2)+'Z');
  }

  ionViewDidEnter(){
    this.address = this.globalvars.getMyGlobalVar();
    this.latitudeMap = this.globalvars.getLatitudeGlobal();
    this.longitudeMap = this.globalvars.getLongitudeGlobal();
    if(this.address){
      this.quedadaForm.controls['direccion'].setValue(this.address);
    }
   
  }

  createQuedada(){
    if(!this.isEdit)
    {
    let nDate = new Date(this.quedadaForm.controls['dateQuedada'].value.substr(0,10)+'T'+this.quedadaForm.controls['dateQuedadaH'].value.substr(11,8));
    let newQuedada={
      "name":this.quedadaForm.controls['titulo'].value,
      "details": this.quedadaForm.controls['queHacer'].value,
      "observations": this.quedadaForm.controls['queSaber'].value,
      "location": this.quedadaForm.controls['direccion'].value,
      "latitude": this.latitudeMap,
      "longitude": this.longitudeMap,
      "maxAttendees": this.quedadaForm.controls['people'].value,
      "duration": this.quedadaForm.controls['duracion'].value,
      "DateTimeUtc":  new Date(this.quedadaForm.controls['dateQuedada'].value + 'T'+ this.quedadaForm.controls['dateQuedadaH'].value).toISOString(),

    }

    

  this.quedadasApiProvider.createQuedada(newQuedada)
    .then(data =>{
      this.navCtrl.pop();
     
    })
    .catch(error =>{
   
    });
  }else{
    this.editQuedada();
  }
  }

  getDateUtc = () =>{
    return new Date(this.dateUTC);
    
  }

  editQuedada(){
    let myDate = this.quedadaForm.controls['dateQuedada'].value.substr(0,10)+'T'+this.quedadaForm.controls['dateQuedadaH'].value.substr(11,9);
    let nDate = new Date(this.quedadaForm.controls['dateQuedada'].value.substr(0,10)+'T'+this.quedadaForm.controls['dateQuedadaH'].value.substr(11,8))
    if(this.isEdit)
    {
      let editQuedada={
        "name":this.quedadaForm.controls['titulo'].value,
        "details": this.quedadaForm.controls['queHacer'].value,
        "observations": this.quedadaForm.controls['queSaber'].value,
        "location": this.quedadaForm.controls['direccion'].value,
        "latitude": this.latitudeMap,
        "longitude": this.longitudeMap,
        "maxAttendees": this.quedadaForm.controls['people'].value,
        "duration": this.quedadaForm.controls['duracion'].value,
        "DateTimeUtc":  nDate
  
      }

      this.quedadasApiProvider.editQuedada(editQuedada, this.quedada.id)
    .then(data =>{
    
      this.navCtrl.pop();
     
    })
    .catch(error =>{
      console.error(error);
    });
  
    }
  }

  

}
