import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams } from 'ionic-angular';
import { Facebook } from '@ionic-native/facebook';
import { LoginServiceProvider } from '../../providers/login-service/login-service';
import { LocalStorageProvider } from '../../providers/local-storage/local-storage';
import { FCM } from '@ionic-native/fcm';
import { Storage }                                           from '@ionic/storage';
import { TwitterConnect } from '@ionic-native/twitter-connect';

@IonicPage()
@Component({
  selector: 'page-login',
  templateUrl: 'login.html',
})
export class LoginPage {
  user: any = {};
  showUser: boolean = false;
  private KEY_TOKEN_PUSH = 'token_push';

  constructor(public navCtrl: NavController, public navParams: NavParams, private facebook: Facebook, private loginServiceProvider: LoginServiceProvider, 
              private localStorageProvider: LocalStorageProvider,public fcm: FCM, public storage: Storage,  private twitter: TwitterConnect) {
              
  }

 

  ionViewDidLoad() {
    
  }

  loginFacebook(){
    this.facebook.login(['public_profile', 'email'])
    .then(rta => {
      if(rta.status == 'connected'){
          this.loginServiceProvider.doSocial('facebook', rta.authResponse.accessToken, null)
          .subscribe(
            (data) => {
        
              this.localStorageProvider.saveToken(JSON.stringify(data));
              this.fcm.getToken().then(tokenPush => {
                this.storage.set(this.KEY_TOKEN_PUSH, tokenPush);
        
                this.loginServiceProvider.registerDevice(tokenPush)
                .then((result) =>{
        
                });
              });
              
              this.navCtrl.setRoot('DashboardPage');
            },
            (error) => {
          
            }
          );
      };
    })
    .catch(error =>{
      console.error( error );
    });
  }

  twLogin(): void {
    this.twitter.login().then( response => {
    
      this.loginServiceProvider.doSocial('twitter', response.token, response.secret)
          .subscribe(
            (data) => {
    
              this.localStorageProvider.saveToken(JSON.stringify(data));
              this.fcm.getToken().then(tokenPush => {
                this.storage.set(this.KEY_TOKEN_PUSH, tokenPush);
    
                this.loginServiceProvider.registerDevice(tokenPush)
                .then((result) =>{
    
                });
              });
              this.navCtrl.setRoot('DashboardPage');
            },
            (error) => {
    
            }
          );
    }, error => {
    
    });
  }
 



  getInfo(){
    this.facebook.api('/me?fields=id,name,email,first_name,picture,last_name,gender',['public_profile','email'])
    .then(data=>{
  
      this.showUser = true; 
      this.user = data;
    
    })
    .catch(error =>{
      console.error( error );
    });
  }

}
