import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { NativeGeocoder, NativeGeocoderReverseResult, NativeGeocoderForwardResult } from '@ionic-native/native-geocoder';
/*
  Generated class for the GeocoderProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
@Injectable()
export class GeocoderProvider {

  constructor(private nativeGeocoder: NativeGeocoder) {
    
  }

  forwardGeocode(keyword : string) : Promise<any>
   {
      return new Promise((resolve, reject) =>
      {
         this.nativeGeocoder.forwardGeocode(keyword)
         .then((coordinates : NativeGeocoderForwardResult) =>
         {
            let str : string   = `The coordinates are latitude=${coordinates.latitude} and longitude=${coordinates.longitude}`;
            resolve(str);
         })
         .catch((error: any) =>
         {
           
            reject(error);
         });
      });
   }

}
